<?php
/*
Plugin Name: LMB^Box Smileys
Plugin URI: http://aboutme.lmbbox.com/
Description: A Clickable Smilies hack for WordPress. Add, edit, remove, and manage the display of your smileys!
Version: 2.1
Author: Thomas Montague
Author URI: http://aboutme.lmbbox.com/
*/ 
/*
LMB^Box Smileys -> Was WP Smileys
version 2.1, 2005-05-17
By Thomas Montague

Orginial WP Grins By Alex King
http://www.alexking.org/software/wordpress/

This is an add-on for WordPress
http://wordpress.org/

LMB^Box Smileys Plugin is for the Bloging System WordPress (www.wordpress.org). It is an easy 
way to add better smiley support to wordpress. Wordpress has a smileys feature built in but it 
doesn't let you click a link or button to see all the smileys available to the user. Now LMB^Box 
Smileys does this and more! You can have LMB^Box Smileys add a button to the Comment Quicktags Menu 
bar (LMB^Box Comment Quicktags Plus Plugin) or you can manually add a link to the smiles to your 
comment.php theme file. Either way, once you click on the button/link, a new window will popup 
and display the smileys page. You can edit the smileys page to display only certain smileys or 
all (more on that in the Installation part below). Also the smileys have css styles set and you 
can add the css tags to your stylesheet to see the results. One last thing, you can add your 
OWN smileys that you make, have, or found! More info in the Installation part below.


== Installation  ==

1. Copy the folder lmbbox-smileys into your wp-content/plugins directory
2. Activate this plugin in the WordPress Admin Panel


#### Additional Steps ####
3. if you want LMB^Box Smileys to automatically add itself to your comments page ....
!!!YOU MUST HAVE LMB^Box COMMENT QUICKTAGS PLUS INSTALLED AND ACTIVATED!!!

	else you have to manually put a link into your comments page like so ...
	<?php echo '<a href="' . get_settings('siteurl') . '/wp-content/plugins/lmbbox-smileys/lmbbox-smileys-popup.php?action=comment" onClick="window.open(\'' . get_settings('siteurl') . '/wp-content/plugins/lmbbox-smileys/lmbbox-smileys-popup.php?action=comment\', \'smileys\', \'width=400,height=450,status=yes,resizable=yes,scrollbars=yes,modal=yes\'); return false;">Smileys</a>'; ?>
	and set "Add Button to Comment Quicktags Toolbar" in the LMB^Box Smileys Option Page to "No".


#### Customize Smileys Page Layout ####
4. To edit the layout and display of the smileys open the file lmbbox-smileys-popup.php and read the directions! They are listed 
below as well:

	At the bottom half of this file, there will be standard html with a php call in the content div. You may edit 
	the look and layout of this part anyway you see fit. To display the smileys, you must call: 

		if ($_GET['action'] == 'admin' && get_settings('use_smilies')) {
		// Admin Write Pages Smileys
			echo lmbbox_smileys($lmbbox_smileys_options['display_for_admin']);
		} elseif ($_GET['action'] == 'comment' && get_settings('use_smilies') && $lmbbox_smileys_options['display_smileys_in_comments']) {
		// Comment Form Smileys
			echo lmbbox_smileys($lmbbox_smileys_options['display_for_comment']);
		} else {
			echo 'Error: Smiley Page called incorrectly!';
		}

	where you want the smileys to be on the page.

	The smiles are returned in a table with a class of lmbbox_smileys_table. To set the styles for the page, go to the bottom 
	half of this file and you will see in the head tags where the style is set (read on!). If you set in the LMB^Box 
	Smileys Options Page to display the smileys with a title, the smileys will be returned with a <h1></h1> heading right 
	before the table, else just the table is returned.


#### Styling the Smileys ####
5. To add styles to the Smileys Page, open the lmbbox-smileys-popup.php and go to the bottom half to the page. You will see some 
normal html code then a styles section. Add your styling there! To add styles to the Smiley Button on the Comment Quicktags 
toolbar, read step 5.2. To add styles to the Smiley Button on the Admin Write Pages Quicktags toolbar, read step 5.3. To add 
styles to the smiley images that are put in the posts or comments, read step 5.4.


****** Styling the Smileys Page ******
	5.1 If you wish to style the Smileys Page just add:

body {
	your style;
}
.lmbbox_smileys {
	your style;
}
.lmbbox_smileys h1 {  
	your style;
}
.lmbbox_smileys h2 {
	your style;
}
.lmbbox_smileys_table {
	your style;
}
.lmbbox_smileys_table tr, .lmbbox_smileys_table td, .lmbbox_smileys_table img {
	your style;
}


****** Styling the Toolbar ******
	5.2 If you wish to style the Smileys button created on the comment page, open your style.css stylesheet file in your 
		theme directory and add:

#comment_quicktags #ed_smileys {
	your style;
}

	5.3 If you wish to style the Smileys button created on the admin write pages, open wp-admin.css in {root}/wp-admin/ 
		folder, find "#ed_del" and add around it:

#ed_smileys {
	your style;
}


****** Styling Smiley Images in Posts and Comments ******
	5.4 If you wish to style the Smiley Images created in the posts and comments, open your style.css stylesheet file in 
		your theme directory and add:

.lmbbox_smileys {
	your style;
}


#### Advanced Features ####
6. Adding your OWN Smileys to the Plugin! To add, edit, manage, and remove the Smileys Lists that are used, go to the 
Management section of your admin contol panel and you will see a subpage named Manage LMB^Box Smileys. Go to this page 
to do all actions of management of the Smileys Lists. To change the display settings for the Smiley List, go to the LMB^Box 
Options Page to set which Smileys Lists are displayed and how. Also you can set if to use Smileys in the comments of your 
blog, if to use the Comment Quicktags Toolbar from LMB^Box Comment Quicktags Toolbar, and set the min. user levels to 
changes settings and manage Smileys Lists.


== End of Installation ==
*/

if (get_settings('use_smilies')) { // if use smilies, then load WP Smileys

	// Here starts all of the default settings. DO NOT edit the settings here! Edit them in the WP Smileys Option page found 
	// under the options menu!

	$lmbbox_smileys_options_default = array (
		'min_user_level'					=> 7,
		'min_user_level_manage'				=> 5,
		'display_smileys_in_comments'		=> 1,
		'use_comment_quicktags_toolbar'		=> 1,
		'display_for_admin'					=> array(
												// false for no display, true for title display, and 2 for no title display
													'wp'	=> 1,
													'tb'	=> 1,
													'ee'	=> 1
												),
		'display_for_comment'				=> array(
												// false for no display, true for title display, and 2 for no title display
													'wp'	=> 1,
													'tb'	=> 1,
													'ee'	=> 1
												)
	);
	$lmbbox_smileys_manage_default = array(
		'smileys_path'				=> ABSPATH . 'wp-content/plugins/lmbbox-smileys/smileys/',
		'smileys_url_path'			=> get_settings('siteurl') . '/wp-content/plugins/lmbbox-smileys/smileys/',
		'smileys_disabled_default'	=> 'disabled_default.gif',
		'smileys_disabled_prefix'	=> 'disabled_',

	// Below is all of the Smileys and their Smiley Code. First are the WP Default Smileys with Modified locations, then
	// there are WYSI-Wordpress 2.0 Plugin's Smileys which come from ThunderBird, and lastly are Smileys EE's Smileys.
		'smileys_list'	=> array(
				// WP Smileys
					'wp'	=> array(
									'title'		=> 'WordPress Smileys',
									'smileys'	=> array(
													//	Smiley Code					Image Name
														':smile_wp:'   			=> 'wp_smile.gif',
														':biggrin_wp:'			=> 'wp_biggrin.gif',
														':sad_wp:'     			=> 'wp_sad.gif',
														':surprised_wp:' 		=> 'wp_surprised.gif',
														':eek_wp:'   			=> 'wp_eek.gif',
														':confused_wp:'  		=> 'wp_confused.gif',
														':cool_wp:'    			=> 'wp_cool.gif',
														':lol_wp:'     			=> 'wp_lol.gif',
														':mad_wp:'     			=> 'wp_mad.gif',
														':razz_wp:'    			=> 'wp_razz.gif',
														':redface_wp:' 			=> 'wp_redface.gif',
														':cry_wp:'     			=> 'wp_cry.gif',
														':evil_wp:'    			=> 'wp_evil.gif',
														':twisted_wp:' 			=> 'wp_twisted.gif',
														':rolleyes_wp:'    		=> 'wp_rolleyes.gif',
														':wink_wp:'    			=> 'wp_wink.gif',
														':exclaim_wp:'     		=> 'wp_exclaim.gif',
														':question_wp:'  		=> 'wp_question.gif',
														':idea_wp:'    			=> 'wp_idea.gif',
														':arrow_wp:'   			=> 'wp_arrow.gif',
														':neutral_wp:' 			=> 'wp_neutral.gif',
														':mrgreen_wp:' 			=> 'wp_mrgreen.gif'
													),
									'disabled'	=> array()
								),
				// TB Smileys
					'tb'	=> array(
									'title'		=> 'ThunderBird Smileys',
									'smileys'	=> array(
													//	Smiley Code					Image Name
														':annoyed_tb:' 			=> 'tb_annoyed.gif',
														':blink_tb:' 			=> 'tb_blink.gif',
														':blush_tb:' 			=> 'tb_blush.gif',
														':bye_tb:' 				=> 'tb_bye.gif',
														':clap_tb:' 			=> 'tb_clap.gif',
														':cool_tb:' 			=> 'tb_cool.gif',
													// last column -> wide image
														':drunk_tb:'			=> 'tb_drunk.gif',
													// last column -> wide image
														':devil_tb:'			=> 'tb_devil.gif',
														':doh_tb:' 				=> 'tb_doh.gif',
														':down_tb:'	 			=> 'tb_down.gif',
														':dry_tb:' 				=> 'tb_dry.gif',
														':dunce_tb:'			=> 'tb_dunce.gif',
														':flush_tb:' 			=> 'tb_flush.gif',
													// last column -> wide image
														':guns_tb:' 			=> 'tb_guns.gif',
													// last column -> wide image
														':furious_tb:' 			=> 'tb_furious.gif',
														':glurps_tb:' 			=> 'tb_glurps.gif',
														':happy_tb:'			=> 'tb_happy.gif',
														':huh_tb:' 				=> 'tb_huh.gif',
														':innocent_tb:' 		=> 'tb_innocent.gif',
														':jittery_tb:' 			=> 'tb_jittery.gif',
													// last column -> wide image
														':smoke_tb:' 			=> 'tb_smoke.gif',
													// last column -> wide image
														':king_tb:' 			=> 'tb_king.gif',
														':laugh_tb:'			=> 'tb_laugh.gif',
														':lol_tb:' 				=> 'tb_lol.gif',
														':mad_tb:' 				=> 'tb_mad.gif',
														':mellow_tb:'			=> 'tb_mellow.gif',
														':nono_tb:' 			=> 'tb_nono.gif',
													// last column -> wide image
														':help_tb:' 			=> 'tb_help.gif',
													// last column -> wide image
														':ohmy_tb:' 			=> 'tb_ohmy.gif',
														':ponder_tb:' 			=> 'tb_ponder.gif',
														':rolleyes_tb:'			=> 'tb_rolleyes.gif',
														':sad_tb:' 				=> 'tb_sad.gif',
														':shock_tb:' 			=> 'tb_shock.gif',
														':sleep_tb:' 			=> 'tb_sleep.gif',
													// last column -> wide image
														':thumbup_tb:' 			=> 'tb_thumbup.gif',
													// last column -> wide image
														':smile_tb:' 			=> 'tb_smile.gif',
														':smileycool_tb:' 		=> 'tb_smiley-cool.gif',
														':cry_tb:' 				=> 'tb_smiley-cry.gif',
														':embarassed_tb:' 		=> 'tb_smiley-embarassed.gif',
														':foot_tb:' 			=> 'tb_smiley-foot-in-mouth.gif',
														':frown_tb:'			=> 'tb_smiley-frown.gif',
													// last column -> wide image
														':thumbdown_tb:' 		=> 'tb_thumbdown.gif',
													// last column -> wide image
														':smileyinnocent_tb:' 	=> 'tb_smiley-innocent.gif',
														':kiss_tb:' 			=> 'tb_smiley-kiss.gif',
														':laughing_tb:' 		=> 'tb_smiley-laughing.gif',
														':money_tb:' 			=> 'tb_smiley-money-mouth.gif',
														':sealed_tb:' 			=> 'tb_smiley-sealed.gif',
														':smileysmile_tb:' 		=> 'tb_smiley-smile.gif',
													// last column -> wide image
														':wallbash_tb:' 		=> 'tb_wallbash.gif',
													// last column -> wide image
														':surprised_tb:' 		=> 'tb_smiley-surprised.gif',
														':tongueout_tb:' 		=> 'tb_smiley-tongue-out.gif',
														':undecided_tb:' 		=> 'tb_smiley-undecided.gif',
														':smileywink_tb:' 		=> 'tb_smiley-wink.gif',
														':yell_tb:' 			=> 'tb_smiley-yell.gif',
														':surrender_tb:' 		=> 'tb_surrender.gif',
														':tongue_tb:' 			=> 'tb_tongue.gif',
														':tongue2_tb:' 			=> 'tb_tongue2.gif',
														':unsure_tb:' 			=> 'tb_unsure.gif',
														':wacko_tb:' 			=> 'tb_wacko.gif',
														':wink_tb:' 			=> 'tb_wink.gif',
														':wub_tb:' 				=> 'tb_wub.gif'
													),
									'disabled'	=> array()
								),
				// EE Smileys
					'ee'	=> array(
									'title'		=> 'EE Smileys',
									'smileys'	=> array(
													//	Smiley Code					Image Name
													    ':grin_ee:'          	=> 'ee_grin.gif',
													    ':lol_ee:'         		=> 'ee_lol.gif',
													    ':cheese_ee:'      		=> 'ee_cheese.gif',
													    ':smile_ee:'      		=> 'ee_smile.gif',
													    ':wink_ee:'          	=> 'ee_wink.gif',
												    	':smirk_ee:'       		=> 'ee_smirk.gif',
													    ':rolleyes_ee:'        	=> 'ee_rolleyes.gif',
													    ':confused_ee:'      	=> 'ee_confused.gif',
												    	':surprise_ee:'     	=> 'ee_surprise.gif',
													    ':bigsurprise_ee:'  	=> 'ee_bigsurprise.gif',
														':tonguelaugh_ee:'  	=> 'ee_tongue_laugh.gif',
												    	':tonguerolleye_ee:' 	=> 'ee_tongue_rolleye.gif',
													    ':tonguewink_ee:'  		=> 'ee_tongue_wink.gif',
													    ':rasberry_ee:'       	=> 'ee_rasberry.gif',
													    ':blank_ee:'       		=> 'ee_blank.gif',
													    ':longface_ee:'        	=> 'ee_longface.gif',
													    ':ohh_ee:'         		=> 'ee_ohh.gif',
												    	':grrr_ee:'        		=> 'ee_grrr.gif',
													    ':gulp_ee:'        		=> 'ee_gulp.gif',
													    ':ohoh_ee:'           	=> 'ee_ohoh.gif',
													    ':downer_ee:'      		=> 'ee_downer.gif',
													    ':embarrassed_ee:'		=> 'ee_embarrassed.gif',
												    	':sick_ee:'        		=> 'ee_sick.gif',
												    	':shuteye_ee:'     		=> 'ee_shuteye.gif',
													    ':hmm_ee:'         		=> 'ee_hmm.gif',
													    ':mad_ee:'         		=> 'ee_mad.gif',
													    ':angry_ee:'       		=> 'ee_angry.gif',
													    ':zip_ee:'         		=> 'ee_zip.gif',
													    ':kiss_ee:'        		=> 'ee_kiss.gif',
												    	':shock_ee:'       		=> 'ee_shock.gif',
													    ':coolsmile_ee:'   		=> 'ee_shade_smile.gif',
													    ':coolsmirk_ee:'   		=> 'ee_shade_smirk.gif',
													    ':coolgrin_ee:'    		=> 'ee_shade_grin.gif',
													    ':coolhmm_ee:'     		=> 'ee_shade_hmm.gif',
													    ':coolmad_ee:'     		=> 'ee_shade_mad.gif',
											    		':coolcheese_ee:'  		=> 'ee_shade_cheese.gif',
												    	':vampire_ee:'     		=> 'ee_vampire.gif',
													    ':snake_ee:'       		=> 'ee_snake.gif',
													    ':exclaim_ee:'     		=> 'ee_exclaim.gif',
													    ':question_ee:'    		=> 'ee_question.gif'
													),
									'disabled'	=> array()
								)
							) // Close smileys_list array
	); // close wp_smileys_manage_default array

	// Check to see if to update settings and get settings
	if (isset($_POST['lmbbox_smileys_options_update'])) {
		$lmbbox_smileys_updated_options = $_POST;
		unset($lmbbox_smileys_updated_options['lmbbox_smileys_options_update']);
		unset($lmbbox_smileys_updated_options['Submit']);
		update_option('lmbbox_smileys_options', $lmbbox_smileys_updated_options);
	}
	if (isset($_POST['lmbbox_smileys_manage_update'])) {
		$lmbbox_smileys_updated_manage = $_POST;
		unset($lmbbox_smileys_updated_manage['lmbbox_smileys_options_update']);
		unset($lmbbox_smileys_updated_manage['select_smileys_list']);
		unset($lmbbox_smileys_updated_manage['Submit']);
		$smiles_list_update = $lmbbox_smileys_updated_manage['smileys_list'];
		unset($lmbbox_smileys_updated_manage['smileys_list']);
		$add_smiles_list = $lmbbox_smileys_updated_manage['add_smileys_list'];
		unset($lmbbox_smileys_updated_manage['add_smileys_list']);
		foreach ($smiles_list_update as $which => $info) {
			$info['abbr'] = preg_replace('@[^0-9a-z\._/-]@i', '', $info['abbr']);
			if ($info['abbr'] != '' && $info['title'] != '' && !$info['remove']) {
				$lmbbox_smileys_updated_manage['smileys_list'][$info['abbr']]['title'] = $info['title'];
				$lmbbox_smileys_updated_manage['smileys_list'][$info['abbr']]['smileys'] = array();
				$lmbbox_smileys_updated_manage['smileys_list'][$info['abbr']]['disabled'] = array();
				foreach ($info['smileys'] as $tag_info) {
					if ($tag_info['tag'] != '' && $tag_info['img'] != '' && !$tag_info['remove']) {
						$lmbbox_smileys_updated_manage['smileys_list'][$info['abbr']]['smileys'][$tag_info['tag']] = $tag_info['img'];
						if ($tag_info['disabled']) {
							$lmbbox_smileys_updated_manage['smileys_list'][$info['abbr']]['disabled'][$tag_info['img']] = true;
						}
					}
				}
			}
		}
		$add_smiles_list['abbr'] = preg_replace('@[^0-9a-z\._/-]@i', '', $add_smiles_list['abbr']);
		if ($add_smiles_list['abbr'] != '' && $add_smiles_list['title'] != '') {
			$lmbbox_smileys_updated_manage['smileys_list'][$add_smiles_list['abbr']]['title'] = $add_smiles_list['title'];
			$lmbbox_smileys_updated_manage['smileys_list'][$add_smiles_list['abbr']]['smileys'] = array();
			$lmbbox_smileys_updated_manage['smileys_list'][$add_smiles_list['abbr']]['disabled'] = array();
			foreach ($add_smiles_list['smileys'] as $tag_info) {
				if ($tag_info['tag'] != '' && $tag_info['img'] != '') {
					$lmbbox_smileys_updated_manage['smileys_list'][$add_smiles_list['abbr']]['smileys'][$tag_info['tag']] = $tag_info['img'];
				}
			}
		}
		update_option('lmbbox_smileys_manage', $lmbbox_smileys_updated_manage);
	}
	// Get and set settings
	if (get_option('lmbbox_smileys_manage') && get_option('lmbbox_smileys_options')) {
		$lmbbox_smileys_options = get_option('lmbbox_smileys_options');
		$lmbbox_smileys_manage = get_option('lmbbox_smileys_manage');
	} elseif (get_option('lmbbox_smileys_options')) {
		$lmbbox_smileys_options = get_option('lmbbox_smileys_options');
		add_option('lmbbox_smileys_manage');
		update_option('lmbbox_smileys_manage', $lmbbox_smileys_manage_default);
		$lmbbox_smileys_manage = get_option('lmbbox_smileys_manage');
	} elseif (get_option('lmbbox_smileys_manage')) {
		add_option('lmbbox_smileys_options');
		update_option('lmbbox_smileys_options', $wp_smileys_options_default);
		$lmbbox_smileys_options = get_option('lmbbox_smileys_options');
		$lmbbox_smileys_manage = get_option('lmbbox_smileys_manage');
	} else {
		add_option('lmbbox_smileys_options');
		update_option('lmbbox_smileys_options', $lmbbox_smileys_options_default);
		$lmbbox_smileys_options = get_option('lmbbox_smileys_options');
		add_option('lmbbox_smileys_manage');
		update_option('lmbbox_smileys_manage', $lmbbox_smileys_manage_default);
		$lmbbox_smileys_manage = get_option('lmbbox_smileys_manage');
	}

	// Reset all smiley info in wordpress
	$lmbbox_smileys_info = array(
		'smileys'	=> array(),
		'search'	=> array(),
		'replace'	=> array()
	);
	$lmbbox_smileys_comments_info = array(
		'smileys'	=> array(),
		'search'	=> array(),
		'replace'	=> array()
	);

	// load new smileys info into arrays
	foreach ($lmbbox_smileys_manage['smileys_list'] as $smileys => $info) {
		if ($lmbbox_smileys_options['display_for_admin'][$smileys]) {
			foreach ($info['smileys'] as $smiley => $img) {
				if ($info['disabled'][$img]) {
					unset($info['smileys'][$smiley]);
				}
			}
			$lmbbox_smileys_info['smileys'] = array_merge($lmbbox_smileys_info['smileys'], $info['smileys']);
		}
		if ($lmbbox_smileys_options['display_for_comment'][$smileys]) {
			foreach ($info['smileys'] as $smiley => $img) {
				if ($info['disabled'][$img]) {
					unset($info['smileys'][$smiley]);
				}
			}
			$lmbbox_smileys_comments_info['smileys'] = array_merge($lmbbox_smileys_comments_info['smileys'], $info['smileys']);
		}
	}

	// generates smilies' search & replace arrays
	foreach($lmbbox_smileys_info['smileys'] as $smiley => $img) {
		$lmbbox_smileys_info['search'][] = $smiley;
		$lmbbox_smileys_info['replace'][] = ' <img class="lmbbox_smileys" src="' . $lmbbox_smileys_manage['smileys_url_path'] . $img . '" alt="' . htmlspecialchars(trim($smiley) , ENT_QUOTES) . '" /> ';
	}
	foreach($lmbbox_smileys_comments_info['smileys'] as $smiley => $img) {
		$lmbbox_smileys_comments_info['search'][] = $smiley;
		$lmbbox_smileys_comments_info['replace'][] = ' <img class="lmbbox_smileys" src="' . $lmbbox_smileys_manage['smileys_url_path'] . $img . '" alt="' . htmlspecialchars(trim($smiley) , ENT_QUOTES) . '" /> ';
	}

	// Functions and filters to replace tags and display smileys
	function lmbbox_smileys_admin_convert($text) {
		global $lmbbox_smileys_info;
	    $output = '';
		if (get_settings('use_smilies')) {
			// HTML loop taken from texturize function, could possible be consolidated
			$textarr = preg_split("/(<.*>)/U", $text, -1, PREG_SPLIT_DELIM_CAPTURE); // capture the tags as well as in between
			$stop = count($textarr);// loop stuff
			for ($i = 0; $i < $stop; $i++) {
				$content = $textarr[$i];
				if ((strlen($content) > 0) && ('<' != $content{0})) { // If it's not a tag
					$content = str_replace($lmbbox_smileys_info['search'], $lmbbox_smileys_info['replace'], $content);
				}
				$output .= $content;
			}
		} else {
			// return default text.
			$output = $text;
		}
		return $output;
	}
	remove_filter('the_content', 'convert_smilies');
	remove_filter('the_excerpt', 'convert_smilies');
	add_filter('the_content', 'lmbbox_smileys_admin_convert');
	add_filter('the_excerpt', 'lmbbox_smileys_admin_convert');

	function lmbbox_smileys_comment_convert($text) {
		global $lmbbox_smileys_comments_info;
	    $output = '';
		if (get_settings('use_smilies')) {
			// HTML loop taken from texturize function, could possible be consolidated
			$textarr = preg_split("/(<.*>)/U", $text, -1, PREG_SPLIT_DELIM_CAPTURE); // capture the tags as well as in between
			$stop = count($textarr);// loop stuff
			for ($i = 0; $i < $stop; $i++) {
				$content = $textarr[$i];
				if ((strlen($content) > 0) && ('<' != $content{0})) { // If it's not a tag
					$content = str_replace($lmbbox_smileys_comments_info['search'], $lmbbox_smileys_comments_info['replace'], $content);
				}
				$output .= $content;
			}
		} else {
			// return default text.
			$output = $text;
		}
		return $output;
	}
	remove_filter('comment_text', 'convert_smilies');
	if ($lmbbox_smileys_options['display_smileys_in_comments']) { add_filter('comment_text', 'lmbbox_smileys_comment_convert'); }


	// Add all content below
	// Insert LMB^Box Smileys Buttons for admin and comments
	function lmbbox_insert_smileys() {
		echo 	'<script language="JavaScript" type="text/javascript">
				<!--
				document.getElementById("ed_toolbar").innerHTML += "<input type=\"button\" class=\"ed_button\" id=\"ed_smileys\" value=\"Smileys\" onclick=\"window.open(\'' . get_settings('siteurl') . '/wp-content/plugins/lmbbox-smileys/lmbbox-smileys-popup.php?action=admin\', \'smileys\', \'width=400,height=450,status=yes,resizable=yes,scrollbars=yes,modal=yes\');\" />";
				//-->
				</script>';
	}
	function lmbbox_insert_smileys_comments() {
		echo 	'<script language="JavaScript" type="text/javascript">
				<!--
				document.getElementById("ed_comment_toolbar").innerHTML += "<input type=\"button\" class=\"ed_button\" id=\"ed_smileys\" value=\"Smileys\" onclick=\"window.open(\'' . get_settings('siteurl') . '/wp-content/plugins/lmbbox-smileys/lmbbox-smileys-popup.php?action=comment\', \'smileys\', \'width=400,height=450,status=yes,resizable=yes,scrollbars=yes,modal=yes\');\" />";
				//-->
				</script>';
	}
	// add_action calls for admin and comment forms
	add_action('simple_edit_form', 'lmbbox_insert_smileys');
	add_action('edit_form_advanced', 'lmbbox_insert_smileys');
	add_action('edit_page_form', 'lmbbox_insert_smileys');
	if ($lmbbox_smileys_options['display_smileys_in_comments'] && $lmbbox_smileys_options['use_comment_quicktags_toolbar']) { add_action('comment_form', 'lmbbox_insert_smileys_comments'); }


	// Smileys Options Page
	function lmbbox_smileys_options_page() {
		global $lmbbox_smileys_options, $lmbbox_smileys_manage;
		if (isset($_POST['lmbbox_smileys_options_update'])) {
			echo '<div class="updated"><p><strong>LMB^Box Smileys Options Updated.</strong></p></div>';
		}
?>
	<div class="wrap">
	<h2>LMB^Box Smileys Options</h2>
	<form name="lmbbox_smileys_options" method="post">
	<input type="hidden" name="lmbbox_smileys_options_update" value="update" />
	<fieldset class="options">
	<table width="100%" cellspacing="2" cellpadding="5" class="editform">
      <tr>
        <th valign="top" scope="row">Minimum Level to Change LMB^Box Smileys Settings :</th>
        <td>
		  <select name="min_user_level">
<?php
	for ($i = 1; $i <= 10; $i++) {
		echo '<option value="' . $i . '" ';
		if ($lmbbox_smileys_options['min_user_level'] == $i) { echo 'selected '; }
		echo '>' . $i . '</option>';
	}
?>
		  </select>
		</td>
      </tr>
      <tr>
        <th valign="top" scope="row">Minimum Level to Manage LMB^Box Smileys :</th>
        <td>
		  <select name="min_user_level_manage">
<?php
	for ($i = 1; $i <= 10; $i++) {
		echo '<option value="' . $i . '" ';
		if ($lmbbox_smileys_options['min_user_level_manage'] == $i) { echo 'selected '; }
		echo '>' . $i . '</option>';
	}
?>
		  </select>
		</td>
      </tr>
      <tr>
        <th valign="top" scope="row">Display Smileys in Comments :</th>
        <td>
		  <label><input type="radio" name="display_smileys_in_comments" value="1" <?php if ($lmbbox_smileys_options['display_smileys_in_comments']) { echo 'checked '; } ?>/> Yes</label><br />
		  <label><input type="radio" name="display_smileys_in_comments" value="0" <?php if (!$lmbbox_smileys_options['display_smileys_in_comments']) { echo 'checked '; } ?>/> No</label><br />
          New Feature: Allows you to decide if you want to disable Smileys display in all comments, but still have Smileys in your posts.
		</td>
      </tr>
      <tr>
        <th valign="top" scope="row">Add Button to Comment Quicktags Toolbar :</th>
        <td>
		  <label><input type="radio" name="use_comment_quicktags_toolbar" value="1" <?php if ($lmbbox_smileys_options['use_comment_quicktags_toolbar']) { echo 'checked '; } ?>/> Yes</label><br />
		  <label><input type="radio" name="use_comment_quicktags_toolbar" value="0" <?php if (!$lmbbox_smileys_options['use_comment_quicktags_toolbar']) { echo 'checked '; } ?>/> No</label><br />
          Add buttons to the Comment Quicktags Toolbar in the Comment Form area. MUST have LMB^Box Comment Quicktags Plugin installed!
		</td>
      </tr>
      <tr>
        <th valign="top" scope="row">Admin Write Pages Display Settings :</th>
        <td>Select which Smileys to display for the Admin Write Pages.<br />
		  <table cellspacing="0" cellpadding="3" border="1" class="editform">
		    <tr bgcolor="#CCCCCC" align="center">
			  <td>Smiley List Name</td>
			  <td>Don't Display</td>
			  <td>Display With Title</td>
			  <td>Display Without Title</td>
			</tr>
<?php
		foreach ($lmbbox_smileys_manage['smileys_list'] as $which => $info) {
			if ($lmbbox_smileys_options['display_for_admin'][$which] == 0) {
				echo '<tr align="center"><td>' . $info['title'] . '</td><td><input type="radio" name="display_for_admin[' . $which . ']" value="0" checked /></td><td><input type="radio" name="display_for_admin[' . $which . ']" value="1" /></td><td><input type="radio" name="display_for_admin[' . $which . ']" value="2" /></td></tr>';
			} elseif ($lmbbox_smileys_options['display_for_admin'][$which] == 1) {
				echo '<tr align="center"><td>' . $info['title'] . '</td><td><input type="radio" name="display_for_admin[' . $which . ']" value="0" /></td><td><input type="radio" name="display_for_admin[' . $which . ']" value="1" checked /></td><td><input type="radio" name="display_for_admin[' . $which . ']" value="2" /></td></tr>';
			} elseif ($lmbbox_smileys_options['display_for_admin'][$which] == 2) {
				echo '<tr align="center"><td>' . $info['title'] . '</td><td><input type="radio" name="display_for_admin[' . $which . ']" value="0" /></td><td><input type="radio" name="display_for_admin[' . $which . ']" value="1" /></td><td><input type="radio" name="display_for_admin[' . $which . ']" value="2" checked /></td></tr>';
			} else {
				echo '<tr align="center"><td>' . $info['title'] . '</td><td><input type="radio" name="display_for_admin[' . $which . ']" value="0" /></td><td><input type="radio" name="display_for_admin[' . $which . ']" value="1" /></td><td><input type="radio" name="display_for_admin[' . $which . ']" value="2" /></td></tr>';
			}
		}
?>
		  </table>
		</td>
      </tr>
      <tr>
        <th valign="top" scope="row">Comment Form Display Settings :</th>
        <td>Select which Smileys to display for the Comment Form.<br />
		  <table cellspacing="0" cellpadding="3" border="1" class="editform">
		    <tr bgcolor="#CCCCCC" align="center">
			  <td>Smiley List Name</td>
			  <td>Don't Display</td>
			  <td>Display With Title</td>
			  <td>Display Without Title</td>
			</tr>
<?php
		foreach ($lmbbox_smileys_manage['smileys_list'] as $which => $info) {
			if ($lmbbox_smileys_options['display_for_comment'][$which] == 0) {
				echo '<tr align="center"><td>' . $info['title'] . '</td><td><input type="radio" name="display_for_comment[' . $which . ']" value="0" checked /></td><td><input type="radio" name="display_for_comment[' . $which . ']" value="1" /></td><td><input type="radio" name="display_for_comment[' . $which . ']" value="2" /></td></tr>';
			} elseif ($lmbbox_smileys_options['display_for_comment'][$which] == 1) {
				echo '<tr align="center"><td>' . $info['title'] . '</td><td><input type="radio" name="display_for_comment[' . $which . ']" value="0" /></td><td><input type="radio" name="display_for_comment[' . $which . ']" value="1" checked /></td><td><input type="radio" name="display_for_comment[' . $which . ']" value="2" /></td></tr>';
			} elseif ($lmbbox_smileys_options['display_for_comment'][$which] == 2) {
				echo '<tr align="center"><td>' . $info['title'] . '</td><td><input type="radio" name="display_for_comment[' . $which . ']" value="0" /></td><td><input type="radio" name="display_for_comment[' . $which . ']" value="1" /></td><td><input type="radio" name="display_for_comment[' . $which . ']" value="2" checked /></td></tr>';
			} else {
				echo '<tr align="center"><td>' . $info['title'] . '</td><td><input type="radio" name="display_for_comment[' . $which . ']" value="0" /></td><td><input type="radio" name="display_for_comment[' . $which . ']" value="1" /></td><td><input type="radio" name="display_for_comment[' . $which . ']" value="2" /></td></tr>';
			}
		}
?>
		  </table>
		</td>
      </tr>
    </table> 
	</fieldset>
	<p class="submit"><input type="submit" name="Submit" value="Update Options &raquo;" /></p>
	</form> 
	</div>
<?php
	}
	function lmbbox_add_smileys_options_page() {
		global $lmbbox_smileys_options;
		add_options_page('LMB^Box Smileys', 'LMB^Box Smileys', $lmbbox_smileys_options['min_user_level'], 'lmbbox-smileys/lmbbox-smileys.php', 'lmbbox_smileys_options_page');
	}
	add_action('admin_menu', 'lmbbox_add_smileys_options_page');


	// Smileys Management Page
	function lmbbox_smileys_manage_page() {
		global $lmbbox_smileys_manage;
		if (isset($_POST['lmbbox_smileys_manage_update'])) {
			echo '<div class="updated"><p><strong>LMB^Box Smileys Management Updated.</strong></p></div>';
		}
?>
	<script language="JavaScript" type="text/javascript">
	<!--
		function edit_smileys_display(field_id) {
			var select_smileys_list = document.lmbbox_smileys_manage.select_smileys_list;
			if (field_id) {
				for (var i = 1; i < select_smileys_list.length; i++) {
					if (select_smileys_list.options[i].value == field_id) {
						document.getElementById(select_smileys_list.options[i].value).style.display = '';
					} else {
						document.getElementById(select_smileys_list.options[i].value).style.display = 'none';
					}
				}
			} else {
				for (var i = 1; i < select_smileys_list.length; i++) {
					document.getElementById(select_smileys_list.options[i].value).style.display = 'none';
				}
			}
		}
		function switch_smiley_image(img_name, img_src, img_disabled, action) {
			if (action && img_name && img_disabled && document.images) {
				document.images[img_name].src = img_disabled;
			} else if (!action && img_name && img_src && document.images) {
				document.images[img_name].src = img_src;
			} else {
				alert('Error: Something went wrong swtiching the Smiley Image!');
			}
		}
	//-->
	</script>
	<div class="wrap">
	<h2>LMB^Box Smileys Management</h2>
	<form name="lmbbox_smileys_manage" method="post">
	<input type="hidden" name="lmbbox_smileys_manage_update" value="update" />
	<fieldset class="options">
	<table width="100%" cellspacing="2" cellpadding="5" class="editform">
      <tr>
        <th valign="top" scope="row">Directory Path to Smileys Images :</th>
        <td>
		  <input type="text" name="smileys_path" size="80" value="<?php echo $lmbbox_smileys_manage['smileys_path']; ?>" /><br />
		  Must end with a "/" !
		</td>
      </tr>
      <tr>
        <th valign="top" scope="row">Url Path to Smileys Images :</th>
        <td>
		  <input type="text" name="smileys_url_path" size="80" value="<?php echo $lmbbox_smileys_manage['smileys_url_path']; ?>" /><br />
		  Must end with a "/" !
		</td>
      </tr>
      <tr>
        <th valign="top" scope="row">Default Disabled Smiley Image :</th>
        <td>
		  <input type="text" name="smileys_disabled_default" value="<?php echo $lmbbox_smileys_manage['smileys_disabled_default']; ?>" /><br />
		  Used if no Disabled Smiley Image, using the Disabled Smileys Image Prefix, is found to display that the Smiley is not avaliable to use on the Smileys Popup Window.
		</td>
      </tr>
      <tr>
        <th valign="top" scope="row">Disabled Smileys Image Prefix :</th>
        <td>
		  <input type="text" name="smileys_disabled_prefix" value="<?php echo $lmbbox_smileys_manage['smileys_disabled_prefix']; ?>" /><br />
		  Used to display that the Smiley is not avaliable to use on the Smileys Popup Window.
		</td>
      </tr>
      <tr>
        <th valign="top" scope="row">Edit Smileys Lists :</th>
        <td>Select which Smileys to edit.<br />
		  <select name="select_smileys_list" style="width: 300px" size="5" onChange="edit_smileys_display(this.value);">
			<option value="false" selected>Don't Bother with this</option>
			<option value="add_smileys_list">Add a Smiley List</option>
<?php
		foreach ($lmbbox_smileys_manage['smileys_list'] as $which => $info) {
			echo '<option value="edit_smileys_list_' . $which . '">' . $info['title'] . '</option>';
		}
?>
			</select>
		</td>
      </tr>
      <tr id="add_smileys_list">
        <th valign="top" scope="row">Smileys Info :</th>
        <td>Create a New Smiley List below.<br />
		  Smileys List Name : <input type="text" name="add_smileys_list[title]" size="30" value="" /> Required! If blank, doesn't add Smiley List!
		  <br />
		  Smileys List Abbreviation : <input type="text" name="add_smileys_list[abbr]" size="6" value="" maxlength="4" /> Required, No Special Chars, Limit 4 Chars! If blank, doesn't add Smiley List!
		  <br /><br />
		  Add Smileys to the list :
		  <br />
		  Column 1 : Add the Smiley's tag to a unique string (best to use ":tag:" format).
		  <br />
		  Column 2 : Add the Smiley's Image File Name.
		  <br />
		  Note : If you have some wide Smileys, put one every 7th Smiley to align them at the end of the table (this will display better, ex: ThunderBird Smileys).
		  <br /><br />
		  <table cellspacing="0" cellpadding="3" border="1" class="editform">
		    <tr bgcolor="#CCCCCC" align="center">
			  <td>Smiley Image Tag</td>
			  <td>Smiley Image File</td>
			</tr>
		    <tr align="center">
			  <td><input type="text" name="add_smileys_list[smileys][0][tag]" size="15" value="" /></td>
			  <td><input type="text" name="add_smileys_list[smileys][0][img]" size="30" value="" /></td>
			</tr>
		    <tr align="center">
			  <td><input type="text" name="add_smileys_list[smileys][1][tag]" size="15" value="" /></td>
			  <td><input type="text" name="add_smileys_list[smileys][1][img]" size="30" value="" /></td>
			</tr>
		    <tr align="center">
			  <td><input type="text" name="add_smileys_list[smileys][2][tag]" size="15" value="" /></td>
			  <td><input type="text" name="add_smileys_list[smileys][2][img]" size="30" value="" /></td>
			</tr>
		    <tr align="center">
			  <td><input type="text" name="add_smileys_list[smileys][3][tag]" size="15" value="" /></td>
			  <td><input type="text" name="add_smileys_list[smileys][3][img]" size="30" value="" /></td>
			</tr>
		    <tr align="center">
			  <td><input type="text" name="add_smileys_list[smileys][4][tag]" size="15" value="" /></td>
			  <td><input type="text" name="add_smileys_list[smileys][4][img]" size="30" value="" /></td>
			</tr>
		    <tr align="center">
			  <td><input type="text" name="add_smileys_list[smileys][5][tag]" size="15" value="" /></td>
			  <td><input type="text" name="add_smileys_list[smileys][5][img]" size="30" value="" /></td>
			</tr>
		    <tr align="center">
			  <td><input type="text" name="add_smileys_list[smileys][6][tag]" size="15" value="" /></td>
			  <td><input type="text" name="add_smileys_list[smileys][6][img]" size="30" value="" /></td>
			</tr>
		  </table>
		</td>
      </tr>
<?php
		foreach ($lmbbox_smileys_manage['smileys_list'] as $which => $info) {
			$i = 0;
?>
      <tr id="edit_smileys_list_<?php echo $which; ?>">
        <th valign="top" scope="row">Smileys Info :</th>
        <td>Set the settings for <?php echo $info['title']; ?> below.<br />
		  Smileys List Name : <input type="text" name="smileys_list[<?php echo $which; ?>][title]" size="30" value="<?php echo $info['title']; ?>" /> Required! If blank, removes Smiley List!
		  <br />
		  Smileys List Abbreviation : <input type="text" name="smileys_list[<?php echo $which; ?>][abbr]" size="6" value="<?php echo $which; ?>" maxlength="4" /> Required, No Special Chars, Limit 4 Chars! If blank, removes Smiley List!
		  <br />
		  Remove Smileys List : <input type="checkbox" name="smileys_list[<?php echo $which; ?>][remove]" value="true" /> Removes Smiley List!
		  <br /><br />
		  Edit the Smileys in the list :
		  <br />
		  Column 1 : Disable a Smiley by checking that Smiley's Disabled Checkbox (Note: Smileys are disabled by image and not tag).
		  <br />
		  Column 2 : What is displayed on the Add Smileys Popup Page.
		  <br />
		  Column 3 : Change the Smiley's tag to a unique string (best to use ":tag:" format).
		  <br />
		  Column 4 : Change the Smiley's Image File Name.
		  <br />
		  Column 5 : Remove the Smiley.
		  <br />
		  Note : If you have some wide Smileys, put one every 7th Smiley to align them at the end of the table (this will display better, ex: ThunderBird Smileys).
		  <br /><br />
		  <table cellspacing="0" cellpadding="3" border="1" class="editform">
		    <tr bgcolor="#CCCCCC" align="center">
			  <td>Disable Smiley!</td>
			  <td>Smiley Image Displayed</td>
			  <td>Smiley Image Tag</td>
			  <td>Smiley Image File</td>
			  <td>Remove Smiley!</td>
			</tr>
<?php
			foreach ($info['smileys'] as $tag => $img) {
				if (!$info['disabled'][$img]) {
					$show_disabled = false;
					if (file_exists($lmbbox_smileys_manage['smileys_path'] . $lmbbox_smileys_manage['smileys_disabled_prefix'] . $img)) {
						$disabled = $lmbbox_smileys_manage['smileys_url_path'] . $lmbbox_smileys_manage['smileys_disabled_prefix'] . $img;
					} else {
						$disabled = $lmbbox_smileys_manage['smileys_url_path'] . $lmbbox_smileys_manage['smileys_disabled_default'];
					}
				} elseif ($info['disabled'][$img] && file_exists($lmbbox_smileys_manage['smileys_path'] . $lmbbox_smileys_manage['smileys_disabled_prefix'] . $img)) {
					$show_disabled = true;
					$disabled = $lmbbox_smileys_manage['smileys_url_path'] . $lmbbox_smileys_manage['smileys_disabled_prefix'] . $img;
				} elseif ($info['disabled'][$img] && !file_exists($lmbbox_smileys_manage['smileys_path'] . $lmbbox_smileys_manage['smileys_disabled_prefix'] . $img)) {
					$show_disabled = true;
					$disabled = $lmbbox_smileys_manage['smileys_url_path'] . $lmbbox_smileys_manage['smileys_disabled_default'];
				}
				$path_img = $lmbbox_smileys_manage['smileys_url_path'] . $img;
				$switch_smiley_image_code = '\'' . $tag . '\', \'' . $path_img . '\', \'' . $disabled . '\'';
?>
		    <tr align="center">
			  <td><input type="checkbox" name="smileys_list[<?php echo $which; ?>][smileys][<?php echo $i; ?>][disabled]" value="true" onClick="switch_smiley_image(<?php echo $switch_smiley_image_code; ?>, this.checked);" <?php if ($show_disabled) { echo 'checked '; } ?>/></td>
			  <td><img name="<?php echo $tag; ?>" src="<?php if ($show_disabled) { echo $disabled; } else { echo $path_img; } ?>" alt="<?php echo $tag; ?>" /></td>
			  <td><input type="text" name="smileys_list[<?php echo $which; ?>][smileys][<?php echo $i; ?>][tag]" size="15" value="<?php echo $tag; ?>" /></td>
			  <td><input type="text" name="smileys_list[<?php echo $which; ?>][smileys][<?php echo $i; ?>][img]" size="30" value="<?php echo $img; ?>" /></td>
			  <td><input type="checkbox" name="smileys_list[<?php echo $which; ?>][smileys][<?php echo $i; ?>][remove]" value="true" /></td>
			</tr>
<?php
				$i++;
			}
?>
		    <tr align="center">
			  <td>Add Me First!</td>
			  <td><img alt="Coming Soon!" /></td>
			  <td><input type="text" name="smileys_list[<?php echo $which; ?>][smileys][<?php echo $i; ?>][tag]" size="15" value="" /></td>
			  <td><input type="text" name="smileys_list[<?php echo $which; ?>][smileys][<?php echo $i; ?>][img]" size="30" value="" /></td>
			  <td>Nope!</td>
			</tr>
		    <tr align="center">
			  <td>Add Me First!</td>
			  <td><img alt="Coming Soon!" /></td>
			  <td><input type="text" name="smileys_list[<?php echo $which; ?>][smileys][<?php echo $i + 1; ?>][tag]" size="15" value="" /></td>
			  <td><input type="text" name="smileys_list[<?php echo $which; ?>][smileys][<?php echo $i + 1; ?>][img]" size="30" value="" /></td>
			  <td>Nope!</td>
			</tr>
		  </table>
		</td>
      </tr>
<?php
		}
?>
    </table>
	</fieldset>
	<p class="submit"><input type="submit" name="Submit" value="Update Options &raquo;" /></p>
	</form> 
	</div>
	<script language="JavaScript" type="text/javascript">edit_smileys_display(false);</script>
<?php
	}
	function lmbbox_add_smileys_manage_page() {
		global $lmbbox_smileys_options;
		add_management_page('Manage LMB^Box Smileys', 'Manage LMB^Box Smileys', $lmbbox_smileys_options['min_user_level_manage'], 'lmbbox-smileys/lmbbox-smileys.php', 'lmbbox_smileys_manage_page');
	}
	add_action('admin_menu', 'lmbbox_add_smileys_manage_page');

} // End if use smilies

?>
